﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Printing;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Zen.Barcode;

namespace BarcodeDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private static readonly BarcodeDraw BarcodeDraw = BarcodeDrawFactory.Code128WithChecksum;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void PrintButton_Click(object sender, RoutedEventArgs e)
        {
            var printDialog = new PrintDialog();

            var printer = new PrintServer().GetPrintQueues().ToList().FirstOrDefault(x => x.FullName.Contains("XPS"));
            if (printer == null)
            {
                MessageBox.Show("No XPS printer found");
                return;
            }
            printDialog.PrintQueue = printer;
            printDialog.PrintTicket.PageOrientation = PageOrientation.Portrait;
            printDialog.PrintTicket.PageMediaSize = new PageMediaSize(PageMediaSizeName.NorthAmericaLetter);
            printDialog.PrintTicket.PageBorderless = PageBorderless.Borderless;

            var drawingVisual = new DrawingVisual();
            var drawingContext = drawingVisual.RenderOpen();
            if (!string.IsNullOrEmpty(InputText.Text))
            {
                var size = new Rect(0, 0, BarcodeControl.ActualWidth, BarcodeControl.ActualHeight);
                BarcodeDraw.Draw(drawingContext, InputText.Text, new BarcodeMetrics1d(2, 4, 60), size);
            }
            drawingContext.Close();

            printDialog.PrintVisual(drawingVisual, "Print");
        }
    }
}
